/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.awt.*;
import java.awt.event.*;

public class AboutBox extends Dialog implements ActionListener {

  Button OKButton;

  public AboutBox(Frame parent, String title, String str1, String str2, String str3) {

    super(parent, "About " + title, false);
    setLayout(new GridBagLayout());
    Label label1=new Label(title);
    Label label2=new Label(str1);
    Label label3=new Label(str2);
    Label label4=new Label(str3);
    Tools.constrain(this,label1,0,0,1,1, GridBagConstraints.NONE, GridBagConstraints.WEST,
		    0.5, 0.25, 20, 20, 0, 10);
    Tools.constrain(this,label2,0,1,1,1, GridBagConstraints.NONE, GridBagConstraints.WEST,
		    0.5, 0.25, 0, 20, 0, 10);
    Tools.constrain(this,label3,0,2,1,1, GridBagConstraints.NONE, GridBagConstraints.WEST,
		    0.5, 0.25, 0, 20, 0, 10);
    Tools.constrain(this,label4,0,3,1,1, GridBagConstraints.NONE, GridBagConstraints.WEST,
		    0.5, 0.25, 0, 20, 20, 10);
    OKButton=new Button("OK");
    OKButton.setSize(72,26);
    Tools.constrain(this,OKButton,1,1,1,2);
    Tools.constrain(this,OKButton,1,1,1,2, GridBagConstraints.NONE, GridBagConstraints.WEST,
		    0.5, 0.5, 0, 10, 0, 20);
    OKButton.addActionListener(this);
    pack();
    //setSize(350,100);
  }

  public synchronized void setVisible(boolean visible) {
    if (visible) {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      setResizable(false);
      super.setVisible(true);
      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      requestFocus();
    }
    else
      super.setVisible(visible);
  }

  public synchronized void wakeUp() {
    notify();
  }

  public void actionPerformed(ActionEvent event) {
    if (event.getSource() == OKButton)
      clickedOKButton();
  }

  public void clickedOKButton() {
    setVisible(false);
    dispose();
  }
};
